#!/bin/sh

#-------- OpenHAB demo configuration files installer script
#-------- package based on work from pcloadletter.co.uk

DOWNLOAD_FILE="openhab-demo-configuration-1.3.1.zip"
DOWNLOAD_PATH="http://openhab.googlecode.com/files"
EXTRACTED_FOLDER="OpenHAB-demo-configuration-1.3.1"
DOWNLOAD_URL="${DOWNLOAD_PATH}/${DOWNLOAD_FILE}"
INSTALL_FILES="${DOWNLOAD_URL}"
source /etc/profile
TEMP_FOLDER="`find / -maxdepth 2 -name '@tmp' | head -n 1`"
PRIMARY_VOLUME="/`echo $TEMP_FOLDER | cut -f2 -d'/'`"


preinst ()
{
  cd ${TEMP_FOLDER}
  for WGET_URL in ${INSTALL_FILES}
  do
    WGET_FILENAME="`echo ${WGET_URL} | sed -r "s%^.*/(.*)%\1%"`"
    [ -f ${TEMP_FOLDER}/${WGET_FILENAME} ] && rm ${TEMP_FOLDER}/${WGET_FILENAME}
    wget ${WGET_URL}
    if [[ $? != 0 ]]; then
      if [ -d ${PUBLIC_FOLDER} ] && [ -f ${PUBLIC_FOLDER}/${DOWNLOAD_FILE} ]; then
        cp ${PUBLIC_FOLDER}/${DOWNLOAD_FILE} ${TEMP_FOLDER}
      else     
        echo "There was a problem downloading ${WGET_FILENAME} from the official download link, "
        echo "which was \"${WGET_URL}\" "
        echo "Alternatively, you may download this file manually and place it in the 'public' shared folder. "
        exit 1
      fi
    fi
  done
  
  exit 0
}


postinst ()
{
  #extract main archive
  cd ${TEMP_FOLDER}
  unzip ${TEMP_FOLDER}/${DOWNLOAD_FILE} -d ${EXTRACTED_FOLDER} && rm ${TEMP_FOLDER}/${DOWNLOAD_FILE}
  cp -r ${TEMP_FOLDER}/${EXTRACTED_FOLDER}/addons/* /var/packages/OpenHAB/target/addons/
  cp -r ${TEMP_FOLDER}/${EXTRACTED_FOLDER}/configurations/* /var/packages/OpenHAB/target/configurations/
# replace demo.rules as TTS is not working with slow cpu's
  cp ${SYNOPKG_PKGDEST}/demo.rules /var/packages/OpenHAB/target/configurations/rules/
  rmdir ${TEMP_FOLDER}/${EXTRACTED_FOLDER}
  
  exit 0
}


preuninst ()
{
  #nothing to do
  exit 0
}


postuninst ()
{
  #remove addons
  rm /var/packages/OpenHAB/target/addons/org.openhab.persistence.rrd4j-1.3.1.jar
  rm /var/packages/OpenHAB/target/addons/org.openhab.persistence.logging-1.3.1.jar
  rm /var/packages/OpenHAB/target/addons/org.openhab.persistence.exec-1.3.1.jar
  rm /var/packages/OpenHAB/target/addons/org.openhab.io.multimedia.tts.freetts-1.3.1.jar
  rm /var/packages/OpenHAB/target/addons/org.openhab.binding.ntp-1.3.1.jar
  rm /var/packages/OpenHAB/target/addons/org.openhab.binding.http-1.3.1.jar
  # remove demo configuration
  rm /var/packages/OpenHAB/target/configurations/items/demo.items
  rm /var/packages/OpenHAB/target/configurations/rules/demo.rules
  rm /var/packages/OpenHAB/target/configurations/scripts/demo.script
  rm /var/packages/OpenHAB/target/configurations/sitemaps/demo.sitemap
#  rm /var/packages/OpenHAB/target/configurations/persistence/logging.persist
  exit 0
}
